package com.jty.wsxt.domain;

import com.jty.wsxt.domain.model.auth.authority.AuthAuthorityRepository;
import com.jty.wsxt.domain.model.auth.authority.nrsc.NrscAuthorityRepository;
import com.jty.wsxt.domain.model.auth.client.ClientRepository;
import com.jty.wsxt.domain.model.auth.history.AuthUserHistoryRepository;
import com.jty.wsxt.domain.model.auth.role.RoleRepository;
import com.jty.wsxt.domain.model.auth.user.UserRepository;
import com.jty.wsxt.domain.model.auth.user.nrsc.NrscTeacherRepository;
import com.jty.wsxt.domain.model.stage.BasicStageRepository;
import com.jty.wsxt.domain.model.subject.BasicSubjectRepository;
import org.springframework.beans.BeansException;
import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationContextAware;
import org.springframework.stereotype.Component;

/**
 * 组件注册
 *
 * @author jason
 * @since 2019/5/20
 */
@Component
public class DomainRegistry implements ApplicationContextAware {

    private static ApplicationContext applicationContext;

    public static NrscAuthorityRepository nrscAuthorityRepository(){
        return applicationContext.getBean(NrscAuthorityRepository.class);
    }

    public static AuthAuthorityRepository authAuthorityRepository(){
        return applicationContext.getBean(AuthAuthorityRepository.class);
    }

    public static RoleRepository roleRepository(){
        return applicationContext.getBean(RoleRepository.class);
    }

    public static UserRepository userRepository(){
        return applicationContext.getBean(UserRepository.class);
    }

    public static ClientRepository clientRepository(){
        return applicationContext.getBean(ClientRepository.class);
    }

    public static BasicStageRepository stageRepository(){
        return applicationContext.getBean(BasicStageRepository.class);
    }

    public static BasicSubjectRepository subjectRepository(){
        return applicationContext.getBean(BasicSubjectRepository.class);
    }

    public static NrscTeacherRepository nrscTeacherRepository(){
        return applicationContext.getBean(NrscTeacherRepository.class);
    }

    public static AuthUserHistoryRepository userHistoryRepository(){
        return applicationContext.getBean(AuthUserHistoryRepository.class);
    }

    @Override
    public synchronized void setApplicationContext(ApplicationContext applicationContext) throws BeansException {
        if(DomainRegistry.applicationContext==null) {
            DomainRegistry.applicationContext = applicationContext;
        }
    }
}
