package com.jty.wsxt.infrastructure.security.embed;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.config.annotation.SecurityConfigurerAdapter;
import org.springframework.security.config.annotation.web.builders.HttpSecurity;
import org.springframework.security.web.DefaultSecurityFilterChain;
import org.springframework.security.web.authentication.preauth.AbstractPreAuthenticatedProcessingFilter;
import org.springframework.stereotype.Component;

/**
 * 嵌入认证过滤器配置
 *
 * @author Jason
 * @since 2019/2/26 15:31
 */
@Component("embedAuthenticationConfig")
public class EmbedAuthenticationConfig extends SecurityConfigurerAdapter<DefaultSecurityFilterChain, HttpSecurity> {

    @Autowired
    private EmbedAuthenticationFilter embedAuthenticationFilter;

    @Override
    public void configure(HttpSecurity http){
        http.addFilterBefore(embedAuthenticationFilter, AbstractPreAuthenticatedProcessingFilter.class);
    }
}
