package com.jty.wsxt.application;

import com.jty.wsxt.application.feign.UserFeign;
import com.jty.wsxt.application.service.ModuleService;
import com.jty.wsxt.application.service.PaperService;
import com.jty.wsxt.application.service.SubjectService;
import com.jty.wsxt.application.service.TypeService;
import org.springframework.beans.BeansException;
import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationContextAware;
import org.springframework.stereotype.Component;

/**
 * 应用Service组件注册
 *
 * @author Manjiajie
 * @since 2019-6-21 09:39:08
 */
@Component
public class ApplicationRegistry implements ApplicationContextAware {

    private static ApplicationContext applicationContext;

    public static UserFeign userFeign(){
        return applicationContext.getBean(UserFeign.class);
    }

    public static ModuleService moduleService(){
        return applicationContext.getBean(ModuleService.class);
    }

    public static PaperService paperService(){
        return applicationContext.getBean(PaperService.class);
    }

    public static SubjectService subjectService(){
        return applicationContext.getBean(SubjectService.class);
    }

    public static TypeService typeService(){
        return applicationContext.getBean(TypeService.class);
    }

    @Override
    public synchronized void setApplicationContext(ApplicationContext applicationContext) throws BeansException {
        if(ApplicationRegistry.applicationContext==null) {
            ApplicationRegistry.applicationContext = applicationContext;
        }
    }
}
