package com.jty.wsxt.application.service.impl;

import com.jty.wsxt.application.service.SubjectService;
import com.jty.wsxt.domain.DomainRegistry;
import com.jty.wsxt.domain.model.module.Module;
import com.jty.wsxt.domain.model.subject.Subject;
import com.jty.wsxt.infrastructure.support.BusinessException;
import com.jty.wsxt.infrastructure.support.ResultCode;
import com.jty.wsxt.interfaces.dto.SubjectDto;
import org.springframework.stereotype.Service;

/**
 * SubjectServiceImpl
 *
 * @author Manjiajie
 * @since 2019-6-21 11:38:53
 */
@Service
public class SubjectServiceImpl implements SubjectService {
    @Override
    public void addSubject(SubjectDto subjectDto) {
        Subject subject = DomainRegistry.subjectRepository().findByName(subjectDto.getName()).orElse(null);
        if(subject != null){
            if(!subject.getUsed()) {
                throw new BusinessException(ResultCode.DATA_ALREADY_EXISTED);
            }else {
                subject.setUsed(true);
            }
        }else {
            subject = new Subject();
            subject.setName(subjectDto.getName());
        }
        subject.save();
    }

    @Override
    public void deleteSubject(Integer subjectId) {
        Subject subject = DomainRegistry.subjectRepository().findById(subjectId).orElseThrow(()->new BusinessException(ResultCode.RESULT_DATA_NONE));
        subject.setUsed(false);
        subject.save();
    }
}
